OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes
NWidgetContainer Class Reference
Hierarchical widgets

Baseclass for container widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetContainer:

## Public Member Functions
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass.
void | Add (NWidgetBase *wid)
| Append widget wid to container.
void | FillNestedArray (NWidgetBase **array, uint length)
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual void | SetupSmallestSize (Window *w, bool init_array)=0
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)=0
| Assign size and position to the widget.
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)=0
| Retrieve a widget by its position.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | Draw (const Window *w)=0
| Draw the widgets of the tree.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Protected Attributes
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Baseclass for container widgets.

Definition at line 368 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetContainer::NWidgetContainer | ( | WidgetType | tp | ) |

Constructor container baseclass.

Parameters

  tp | Type of the container.

Definition at line 914 of file widget.cpp.

References head, and tail.

## Member Function Documentation

void NWidgetContainer::Add | ( | NWidgetBase * | wid | ) |

Append widget wid to container.

Parameters

  wid | Widget to append.

Definition at line 944 of file widget.cpp.

References head, NWidgetBase::next, NWidgetBase::prev, and tail.

Referenced by NWidgetBackground::Add(), AddKey(), CargoWidgets(), MakeCargoButtons(), MakeCompanyButtonRows(), MakeMainToolbar(), MakeNWidgetCompanyLines(), MakePerformanceDetailPanels(), MakeWidgetTree(), and MakeWindowNWidgetTree().

NWidgetBase * NWidgetContainer::GetWidgetOfType | ( | WidgetType | tp | ) |
| virtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `NULL` if no widget can be found.

Reimplemented from NWidgetBase.

Definition at line 930 of file widget.cpp.

References NWidgetBase::GetWidgetOfType(), head, NWidgetBase::next, and NWidgetBase::type.

Referenced by NWidgetBackground::GetWidgetOfType(), and MakeWindowNWidgetTree().

bool NWidgetContainer::IsEmpty | ( |  | ) |
| inline

Return whether the container is empty.

Definition at line 377 of file widget_type.h.

References head.

Referenced by AddKey().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp